<!DOCTYPE html>
<html lang="en">
<head>
    <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=0"/>
    <meta charset="utf-8"/>
    <title>API Documentation &raquo;\PhpOffice\PhpSpreadsheet\Shared\JAMA\SingularValueDecomposition</title>
    <meta name="author" content=""/>
    <meta name="description" content=""/>        <link href="../css/template.css" rel="stylesheet" media="all"/>        <!--[if lt IE 9]>
        <script src="https://html5shim.googlecode.com/svn/trunk/html5.js" type="text/javascript"></script>
        <![endif]-->
        <script src="../js/jquery-1.7.1.min.js" type="text/javascript"></script>
        <script src="../js/jquery-ui-1.8.2.custom.min.js" type="text/javascript"></script>
        <script src="../js/jquery.mousewheel.min.js" type="text/javascript"></script>
        <script src="../js/bootstrap.js" type="text/javascript"></script>
        <script src="../js/template.js" type="text/javascript"></script>
        <script src="../js/prettify/prettify.min.js" type="text/javascript"></script>        <link rel="shortcut icon" href="../img/favicon.ico"/>
        <link rel="apple-touch-icon" href="../img/apple-touch-icon.png"/>
        <link rel="apple-touch-icon" sizes="72x72" href="../img/apple-touch-icon-72x72.png"/>
        <link rel="apple-touch-icon" sizes="114x114" href="../img/apple-touch-icon-114x114.png"/></head>
<body>    <div class="navbar navbar-fixed-top">
        <div class="navbar-inner">
            <div class="container">
                <a class="btn btn-navbar" data-toggle="collapse" data-target=".nav-collapse">
                    <span class="icon-bar"></span> <span class="icon-bar"></span>
                    <span class="icon-bar"></span> </a>
                <a class="brand" href="../index.html">API Documentation</a>

                <div class="nav-collapse">
                    <ul class="nav">
                        <li class="dropdown">
                            <a href="#api" class="dropdown-toggle" data-toggle="dropdown">
                                API Documentation <b class="caret"></b>
                            </a>
                            <ul class="dropdown-menu">                                    <li><a>Namespaces</a></li>                                    <li><a href="../namespaces/task_23.html">task_23</a></li>                                    <li><a href="../namespaces/task_18.html">task_18</a></li>                                    <li><a href="../namespaces/task_22.html">task_22</a></li>                                    <li><a href="../namespaces/Composer.html">Composer</a></li>                                    <li><a href="../namespaces/Matrix.html">Matrix</a></li>                                    <li><a href="../namespaces/Complex.html">Complex</a></li>                                    <li><a href="../namespaces/Psr.html">Psr</a></li>                                    <li><a href="../namespaces/PhpOffice.html">PhpOffice</a></li>                                    <li><a href="../namespaces/Samples.html">Samples</a></li>                                    <li><a href="../namespaces/task_21.html">task_21</a></li>                                    <li><a href="../namespaces/task_24.html">task_24</a></li>                                    <li><a href="../namespaces/task_20.html">task_20</a></li>                                    <li><a href="../namespaces/task_17.html">task_17</a></li>                                    <li><a href="../namespaces/task_19.html">task_19</a></li>                            </ul>
                        </li>
                        <li class="dropdown" id="charts-menu">
                            <a href="#charts" class="dropdown-toggle" data-toggle="dropdown">
                                Charts <b class="caret"></b>
                            </a>
                            <ul class="dropdown-menu">
                                <li>
                                    <a href="../graph_class.html">
                                        <i class="icon-list-alt"></i>&#160;Class hierarchy diagram
                                    </a>
                                </li>
                            </ul>
                        </li>
                        <li class="dropdown" id="reports-menu">
                            <a href="#reports" class="dropdown-toggle" data-toggle="dropdown">
                                Reports <b class="caret"></b>
                            </a>
                            <ul class="dropdown-menu">
                                <li>
                                    <a href="../errors.html">
                                        <i class="icon-list-alt"></i>&#160;Errors
                                    </a>
                                </li>
                                <li>
                                    <a href="../markers.html">
                                        <i class="icon-list-alt"></i>&#160;Markers
                                    </a>
                                </li>
                                <li>
                                    <a href="../deprecated.html">
                                        <i class="icon-list-alt"></i>&#160;Deprecated
                                    </a>
                                </li>
                            </ul>
                        </li>
                    </ul>
                </div>
            </div>
        </div>
        <div class="go_to_top">
            <a href="#___" style="color: inherit">Back to top&#160;&#160;<i class="icon-upload icon-white"></i></a>
        </div>
    </div>
    <div id="___" class="container">
        <noscript>
            <div class="alert alert-warning">
                Javascript is disabled; several features are only available if Javascript is enabled.
            </div>
        </noscript>    <style>
        .deprecated h2 {
            text-decoration: line-through;
        }
    </style>
    <div class="row">
        <div class="span4">    <div class="btn-group view pull-right" data-toggle="buttons-radio">
        <button class="btn details" title="Show descriptions and method names"><i class="icon-list"></i></button>
        <button class="btn simple" title="Show only method names"><i class="icon-align-justify"></i></button>
    </div>
    <div class="btn-group visibility" data-toggle="buttons-checkbox">
        <button class="btn public active" title="Show public elements">Public</button>
        <button class="btn protected" title="Show protected elements">Protected</button>
        <button class="btn private" title="Show private elements">Private</button>
        <button class="btn inherited active" title="Show inherited elements">Inherited</button>
    </div>    <ul class="side-nav nav nav-list">
        <li class="nav-header">
            <i class="icon-custom icon-method"></i> Methods
            <ul>    <li class="methodpublic">
        <a href="#method___construct" title="__construct ::Construct the singular value decomposition.">
            <span class="description">Construct the singular value decomposition.</span><pre>__construct</pre>
        </a>
    </li>    <li class="methodpublic">
        <a href="#method_cond" title="cond ::Two norm condition number.">
            <span class="description">Two norm condition number.</span><pre>cond</pre>
        </a>
    </li>    <li class="methodpublic">
        <a href="#method_getS" title="getS ::Return the diagonal matrix of singular values.">
            <span class="description">Return the diagonal matrix of singular values.</span><pre>getS</pre>
        </a>
    </li>    <li class="methodpublic">
        <a href="#method_getSingularValues" title="getSingularValues ::Return the one-dimensional array of singular values.">
            <span class="description">Return the one-dimensional array of singular values.</span><pre>getSingularValues</pre>
        </a>
    </li>    <li class="methodpublic">
        <a href="#method_getU" title="getU ::Return the left singular vectors.">
            <span class="description">Return the left singular vectors.</span><pre>getU</pre>
        </a>
    </li>    <li class="methodpublic">
        <a href="#method_getV" title="getV ::Return the right singular vectors.">
            <span class="description">Return the right singular vectors.</span><pre>getV</pre>
        </a>
    </li>    <li class="methodpublic">
        <a href="#method_norm2" title="norm2 ::Two norm.">
            <span class="description">Two norm.</span><pre>norm2</pre>
        </a>
    </li>    <li class="methodpublic">
        <a href="#method_rank" title="rank ::Effective numerical matrix rank.">
            <span class="description">Effective numerical matrix rank.</span><pre>rank</pre>
        </a>
    </li>            </ul>
        </li>
        <li class="nav-header protected">» Protected
            <ul>            </ul>
        </li>
        <li class="nav-header private">» Private
            <ul>            </ul>
        </li>
        <li class="nav-header">
            <i class="icon-custom icon-constant"></i> Constants
            <ul>            </ul>
        </li>
    </ul>
        </div>

        <div class="span8">
            <div class="element class">
                <h1>SingularValueDecomposition</h1>
                <small style="display: block; text-align: right">                </small>
                <p class="short_description">For an m-by-n matrix A with m &gt;= n, the singular value decomposition is
   an m-by-n orthogonal matrix U, an n-by-n diagonal matrix S, and
   an n-by-n orthogonal matrix V so that A = U*S*V&#039;.</p>
                <div class="details">
                    <div class="long_description"><p>The singular values, sigma[$k] = S[$k][$k], are ordered so that
sigma[0] &gt;= sigma[1] &gt;= ... &gt;= sigma[n-1].</p>
<p>The singular value decompostion always exists, so the constructor will
never fail.  The matrix condition number and the effective numerical
rank can be computed from this decomposition.</p>
                    </div>
                    <table class="table table-bordered">                                <tr>
                                    <th>author                                    </th>
                                    <td><p>Paul Meagher</p>
<p>@version 1.1</p>
                                    </td>
                                </tr>                                <tr>
                                    <th>package                                    </th>
                                    <td><p>Default</p>
                                    </td>
                                </tr>                    </table>

                    <h3><i class="icon-custom icon-method"></i> Methods</h3>                        <a id="method___construct"></a>
                        <div class="element clickable methodpublic method___construct" data-toggle="collapse" data-target=".method___construct .collapse">
                            <h2>Construct the singular value decomposition.</h2>
                            <pre>__construct(mixed $Arg)</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"><p>Derived from LINPACK code.</p></div>

                                    <table class="table">                                            <tr>
                                                <th>
                                                </th>
                                                <td>                                                </td>
                                            </tr>                                    </table>                                        <h3>Arguments</h3>                                            <div class="subelement argument">
                                                <h4>$Arg</h4>
                                                <code>mixed</code><p><p>Rectangular matrix</p></p>
                                            </div>                                </div>
                            </div>

                        </div>                        <a id="method_cond"></a>
                        <div class="element clickable methodpublic method_cond" data-toggle="collapse" data-target=".method_cond .collapse">
                            <h2>Two norm condition number.</h2>
                            <pre>cond(): float</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"></div>

                                    <table class="table">                                            <tr>
                                                <th>
                                                </th>
                                                <td>                                                </td>
                                            </tr>                                    </table>                                        <h3>Response</h3>
                                        <code>float</code><p><p>max(S)/min(S)</p></p>                                </div>
                            </div>

                        </div>                        <a id="method_getS"></a>
                        <div class="element clickable methodpublic method_getS" data-toggle="collapse" data-target=".method_getS .collapse">
                            <h2>Return the diagonal matrix of singular values.</h2>
                            <pre>getS(): \PhpOffice\PhpSpreadsheet\Shared\JAMA\Matrix</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"></div>

                                    <table class="table">                                            <tr>
                                                <th>
                                                </th>
                                                <td>                                                </td>
                                            </tr>                                    </table>                                        <h3>Response</h3>
                                        <code>\PhpOffice\PhpSpreadsheet\Shared\JAMA\Matrix</code><p><p>S</p></p>                                </div>
                            </div>

                        </div>                        <a id="method_getSingularValues"></a>
                        <div class="element clickable methodpublic method_getSingularValues" data-toggle="collapse" data-target=".method_getSingularValues .collapse">
                            <h2>Return the one-dimensional array of singular values.</h2>
                            <pre>getSingularValues(): array</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"></div>

                                    <table class="table">                                            <tr>
                                                <th>
                                                </th>
                                                <td>                                                </td>
                                            </tr>                                    </table>                                        <h3>Response</h3>
                                        <code>array</code><p><p>diagonal of S</p></p>                                </div>
                            </div>

                        </div>                        <a id="method_getU"></a>
                        <div class="element clickable methodpublic method_getU" data-toggle="collapse" data-target=".method_getU .collapse">
                            <h2>Return the left singular vectors.</h2>
                            <pre>getU(): \PhpOffice\PhpSpreadsheet\Shared\JAMA\Matrix</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"></div>

                                    <table class="table">                                            <tr>
                                                <th>
                                                </th>
                                                <td>                                                </td>
                                            </tr>                                    </table>                                        <h3>Response</h3>
                                        <code>\PhpOffice\PhpSpreadsheet\Shared\JAMA\Matrix</code><p><p>U</p></p>                                </div>
                            </div>

                        </div>                        <a id="method_getV"></a>
                        <div class="element clickable methodpublic method_getV" data-toggle="collapse" data-target=".method_getV .collapse">
                            <h2>Return the right singular vectors.</h2>
                            <pre>getV(): \PhpOffice\PhpSpreadsheet\Shared\JAMA\Matrix</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"></div>

                                    <table class="table">                                            <tr>
                                                <th>
                                                </th>
                                                <td>                                                </td>
                                            </tr>                                    </table>                                        <h3>Response</h3>
                                        <code>\PhpOffice\PhpSpreadsheet\Shared\JAMA\Matrix</code><p><p>V</p></p>                                </div>
                            </div>

                        </div>                        <a id="method_norm2"></a>
                        <div class="element clickable methodpublic method_norm2" data-toggle="collapse" data-target=".method_norm2 .collapse">
                            <h2>Two norm.</h2>
                            <pre>norm2(): float</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"></div>

                                    <table class="table">                                            <tr>
                                                <th>
                                                </th>
                                                <td>                                                </td>
                                            </tr>                                    </table>                                        <h3>Response</h3>
                                        <code>float</code><p><p>max(S)</p></p>                                </div>
                            </div>

                        </div>                        <a id="method_rank"></a>
                        <div class="element clickable methodpublic method_rank" data-toggle="collapse" data-target=".method_rank .collapse">
                            <h2>Effective numerical matrix rank.</h2>
                            <pre>rank(): integer</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"></div>

                                    <table class="table">                                            <tr>
                                                <th>
                                                </th>
                                                <td>                                                </td>
                                            </tr>                                    </table>                                        <h3>Response</h3>
                                        <code>integer</code><p><p>Number of nonnegligible singular values</p></p>                                </div>
                            </div>

                        </div>                        <h3><i class="icon-custom icon-property"></i> Properties</h3>                            <a id="property_U"> </a>
                            <div class="element clickable propertyprivate property_U" data-toggle="collapse" data-target=".property_U .collapse">
                                <h2>Internal storage of U.</h2>
                                <pre>U :array</pre>
                                <div class="labels">                                </div>
                                <div class="row collapse">
                                    <div class="detail-description">
                                        <div class="long_description"></div>

                                        <table class="table">                                                <tr>
                                                    <th>var
                                                    </th>
                                                    <td>                                                    </td>
                                                </tr>                                        </table>                                            <h3>Type(s)</h3>
                                            <code>array</code>                                    </div>
                                </div>
                            </div>                            <a id="property_V"> </a>
                            <div class="element clickable propertyprivate property_V" data-toggle="collapse" data-target=".property_V .collapse">
                                <h2>Internal storage of V.</h2>
                                <pre>V :array</pre>
                                <div class="labels">                                </div>
                                <div class="row collapse">
                                    <div class="detail-description">
                                        <div class="long_description"></div>

                                        <table class="table">                                                <tr>
                                                    <th>var
                                                    </th>
                                                    <td>                                                    </td>
                                                </tr>                                        </table>                                            <h3>Type(s)</h3>
                                            <code>array</code>                                    </div>
                                </div>
                            </div>                            <a id="property_s"> </a>
                            <div class="element clickable propertyprivate property_s" data-toggle="collapse" data-target=".property_s .collapse">
                                <h2>Internal storage of singular values.</h2>
                                <pre>s :array</pre>
                                <div class="labels">                                </div>
                                <div class="row collapse">
                                    <div class="detail-description">
                                        <div class="long_description"></div>

                                        <table class="table">                                                <tr>
                                                    <th>var
                                                    </th>
                                                    <td>                                                    </td>
                                                </tr>                                        </table>                                            <h3>Type(s)</h3>
                                            <code>array</code>                                    </div>
                                </div>
                            </div>                            <a id="property_m"> </a>
                            <div class="element clickable propertyprivate property_m" data-toggle="collapse" data-target=".property_m .collapse">
                                <h2>Row dimension.</h2>
                                <pre>m :integer</pre>
                                <div class="labels">                                </div>
                                <div class="row collapse">
                                    <div class="detail-description">
                                        <div class="long_description"></div>

                                        <table class="table">                                                <tr>
                                                    <th>var
                                                    </th>
                                                    <td>                                                    </td>
                                                </tr>                                        </table>                                            <h3>Type(s)</h3>
                                            <code>integer</code>                                    </div>
                                </div>
                            </div>                            <a id="property_n"> </a>
                            <div class="element clickable propertyprivate property_n" data-toggle="collapse" data-target=".property_n .collapse">
                                <h2>Column dimension.</h2>
                                <pre>n :integer</pre>
                                <div class="labels">                                </div>
                                <div class="row collapse">
                                    <div class="detail-description">
                                        <div class="long_description"></div>

                                        <table class="table">                                                <tr>
                                                    <th>var
                                                    </th>
                                                    <td>                                                    </td>
                                                </tr>                                        </table>                                            <h3>Type(s)</h3>
                                            <code>integer</code>                                    </div>
                                </div>
                            </div>                </div>
            </div>
            <a id="\PhpOffice\PhpSpreadsheet\Shared\JAMA\SingularValueDecomposition"></a>
            <ul class="breadcrumb">
                <li><a href="../index.html"><i class="icon-custom icon-class"></i></a></li>
    <li><span class="divider">\</span><a href="../namespaces/PhpOffice.PhpSpreadsheet.Shared.JAMA.html">JAMA</a></li>
                <li class="active"><span class="divider">\</span><a href="../classes/PhpOffice.PhpSpreadsheet.Shared.JAMA.SingularValueDecomposition.html">SingularValueDecomposition</a></li>
            </ul>
        </div>
    </div>    </div>    <footer class="span12">
            Template is built using <a href="http://twitter.github.com/bootstrap/">Twitter Bootstrap 2</a> and icons provided by
            <a href="http://glyphicons.com/">Glyphicons</a>.<br/>
            Documentation is powered by <a href="http://www.phpdoc.org/">phpDocumentor</a> and<br/>
            generated onFri, 14 Feb 2020 19:36:49 +0000.<br/>
    </footer></body>
</html>
